/*

@echo off
cls
echo.
echo This INSTALL routine requires OS/2 REXX support installed.
echo Run Selective Installation from the OS/2 Setup Folder to
echo install REXX support before attempting to run this CMD file.
pause
exit

       *-------------------------------------------------------------*
       |                                                             |
       |                  JFTP OS/2 INSTALL SCRIPT                   |
       |                                                             |
       |           INSTOS2.CMD - Install procedure for JFTP          |
       |                                                             |
       |              written by Juergen Ulbts (Germany)             |
       |                                                             |
       *-------------------------------------------------------------*
*/

PARSE ARG arg '[' WarpIN ']'

'@echo off'

BootDrive             = ''
InstallPath           = directory()
InstallPathFWSlash    = TRANSLATE(InstallPath,'/','\');  /* replace all "\" with "/" */
JavaEXEString         = 'JAVA.EXE'
searchJavaString01    = 'JAVA'
JDKInstallPath        = ''
Icon                  = InstallPath||'\jftp40os2.ico'
ErrorCodeJAVA         = 0     /* ErrorCodes: 11=Java not found,...  */

CopyrightLine1  = 'OS/2 Install script for the JFTP'
CopyrightLine2  = 'written by Juergen Ulbts (Germany) in 2004!'
CopyrightLine3  = ''
CopyrightLine4  = 'JFTP - The Universal FTP Client'
CopyrightLine5  = 'The latest version can be found at: http://www.jMethods.com'

/* Load REXXUTIL */
call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs
call sysloadfuncs


AvailDrives = SysDriveMap('C:', 'LOCAL')

/* Get boot drive letter */
done = 0
do while \ done
  IF WarpIN >< "WarpIN" then call ShowScriptCopyright
  BootDrive=GetBootDrive()
  done = 1
end

/* get the name of the dbDriver that has to be added to the startup script */
call getJavaVersionFromBootDrive
if ErrorCodeJAVA = 0 then
  if JDKInstallPath='' then ErrorCodeJAVA = 11

/* Check if this is an automatically called script... */
if WarpIN = "WarpIN" then do
   call CreateSTARTOS2CMD_NOOUTPUT
   EXIT
end /* do */




/* --------------- */
if (ErrorCodeJAVA=0) then
	do forever   /* main selection loop */
		call ShowScriptCopyright
		say 'Select one of the following:'
		say
		say '  0. Exit JFTP install'
		say '  1. Create JFTP Desktop objects (incl startos2*.cmd)'
		say '  2. Create JFTP "startos2*.cmd"'
		say
		say '  ESC to quit'
		say
		call charout, 'Press 0,1,2 or ESC: '
		do forever 
			k = translate(SysGetKey('NOECHO'))
			if k = '0' | k = D2C(27) then
				call InstallEnd
			else do
				if k = '1' then do
					call CreatePMObjects
					leave
				end
			
				if k = '2' then do
					call CreateSTARTOS2CMD
					leave
				end
			end
			call beep 1760, 50
		end 
	end /* do forever */
/* --------------- */

Select
   when ErrorCodeJRE=11 then do
        say 'ERROR 11: Java Runtime not found! You have to manually update the CMD file!'
        say
        call PressAnyKey
        call InstallEnd
   end /* do */
        
   otherwise
        call InstallEnd
end  /* select */




/* ===================================== */
/*  ADDITIONAL PROCEDURES AND FUNCTIONS  */
/* ===================================== */


/* Create PM Objects on Desktop */
CreatePMObjects:
  call ShowScriptCopyright
  say
  call CreateSTARTOS2CMD_NOOUTPUT

  if SysCreateObject("WPFolder","JFTP","<WP_DESKTOP>", "OBJECTID=<JFTP_Folder>", "R") Then Do
    if SysCreateObject("WPProgram", "JFTP",               "<JFTP_Folder>",  "EXENAME="InstallPath"\STARTOS2.CMD;STARTUPDIR="InstallPath";ICONFILE="Icon, "R") then 
      if SysCreateObject("WPProgram", "JFTP-JavaDebug",    "<JFTP_Folder>",  "EXENAME="InstallPath"\STARTOS2DEBUG.CMD;STARTUPDIR="InstallPath";ICONFILE="Icon, "R") then 
        if SysCreateObject("WPUrl", "JFTP Readme", "<JFTP_Folder>", "NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=file:///"||InstallPathFWSlash||"/readme.html", "R") then
          if SysCreateObject("WPUrl", "JFTP HomePage", "<JFTP_Folder>","NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://www.jMethods.com;", "R") then
          say 'All objects were created!'
        Else say 'Failed to create readme url object!'
      Else say 'Failed to create JavaDebug program object!'
    Else say 'Failed to create program object!'
  Else say 'Failed to create folder on the desktop! No other objects were created!'
  END

  call PressAnyKey
  return




/* Create startos2.cmd */
CreateSTARTOS2CMD:
  call ShowScriptCopyright
  say
  startfile = 'startos2.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "REM You may have to add the path to the Java1xx runtime ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVAW.EXE -jar ./lib/jftp.jar")
  say 'STARTOS2.CMD created.'

  startfile = 'startos2debug.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "REM You may have to add the path to the Java1xx runtime ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVA.EXE -jar ./lib/jftp.jar")
  say 'STARTOS2DEBUG.CMD created.'

  call PressAnyKey
  return


/* Create startos2.cmd without screen output */
CreateSTARTOS2CMD_NOOUTPUT:
  startfile = 'startos2.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF" )
  rc = lineout(startfile, "REM You may have to add the path to the Java1xx runtime ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVAW.EXE -jar ./lib/jftp.jar")
  
  startfile = 'startos2debug.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF" )
  rc = lineout(startfile, "REM You may have to add the path to the Java1xx runtime ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVA.EXE -jar ./lib/jftp.jar")
  return


/* Show script copyright notice */
ShowScriptCopyright:
  call SysCls
  say
  say
  say CopyrightLine1
  say CopyrightLine2
  say CopyrightLine3
  say
  say CopyrightLine4
  say CopyrightLine5
  say
  say
  return


/* Get installed JAVA version from the BootDrive */
getJavaVersionFromBootDrive:
   rc = SysFileTree(BootDrive||'\'||searchJavaString01||'*', 'javaSysFileDir', 'DO')
   do jreCounter=javaSysFileDir.0 to 1 by -1
      PARSE UPPER VAR javaSysFileDir.jreCounter javaStr 

/* say 'JAVA Verzeichnis: '||javaStr */

      /* Start - Search in Directory for JAVA.EXE file... */
      rc = SysFileTree(javaStr||'\BIN\'||JavaEXEString, 'javaEXESysFileDir', 'FSO')
      do jreCounterEXE=1 to javaEXESysFileDir.0
         PARSE UPPER VAR javaEXESysFileDir.jreCounterEXE JDKInstallPath 'JAVA.EXE'
      end /* do - javaEXESysFileDir */

      if javaEXEPath='' then do
         rc = SysFileTree(javaStr||'\JRE\'||JavaEXEString, 'javaEXESysFileDir', 'FSO')
         do jreCounterEXE=1 to javaEXESysFileDir.0
            PARSE UPPER VAR javaEXESysFileDir.jreCounterEXE JDKInstallPath 'JAVA.EXE'
         end   /* do - javaEXESysFileDir */
      end /* do - if then */
      /* End - Search in Directory for JAVA.EXE file... */
      
/* say 'Java EXE Path: '||JDKInstallPath */

      if JDKInstallPath><'' then LEAVE
      
   end /* do - javaSysFileDir - Search for x:\JAVA* directories */

  return JDKInstallPath
/* END GetJavaVersionFromBootDrive*/



/* Wait for a key press */
PressAnyKey:
  call charout, 'Press any key to continue...'
  call SysGetKey 'NOECHO'
  return



/* Get path from user */
GetPath:
  call charout, '> '
  parse pull APath
  len = length(APath)
  if len > 0 then
    if substr(APath, len, 1) = '\' then
      APath = substr(APath, 1, len-1)
  return APath


/* Get Bootdrive */
GetBootDrive: Procedure
If \Rxfuncquery('SysBootDrive') Then
   bootdrive = SysBootDrive()       /* Object or Updated Classic Rexx */
Else
   Do
      If \Rxfuncquery('RxBootDrive') Then
         bootdrive = RxBootDrive()                        /* RxExtras */
      Else
         Do                       /* Examine various config.sys items */
            Parse Upper Value Value('PATH', ,'OS2ENVIRONMENT') ,
               With ':\OS2\SYSTEM' - 1 bootdrive + 2
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('RUNWORKPLACE', ,'OS2ENVIRONMENT'), 1, 2 )
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('COMSPEC', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('OS2_SHELL', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('SYSTEM_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('USER_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then                      /* no guesses */
               bootdrive = 0
         End
   End
Return bootdrive               /* Returns BootDrive, letter and colon */



/* End message */
InstallEnd:
  call SysCls
  say
  say
  say 'JFTP INSTALL ended.'
  exit

